﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DotNettyFrom.config;
using DotNettyFrom.db;
using DotNettyFrom.model;
using DotNettyFrom.util;

namespace DotNettyFrom.generatecmd
{
    public class Water2CmdGenetor : CmdGenetor
    {
        public override string GetLoginCmd(string ccid)
        {
            string cmd = DeviceId + "0214" + ccid;
            return "7e7e7e" + CmdUtil.CalcCrc16Code(cmd);
        }

        public override string GetHeartbeat()
        {
            string cmd = DeviceId + "03020001";
            return "7e7e7e" + CmdUtil.CalcCrc16Code(cmd).ToUpper();
        }

        public override string GetReplyCmd(string receiveCmd)
        {
            int cmdId = GetCmdId(receiveCmd);


            if (cmdId == int.MinValue)
            {
                return null;
            }

            WvBean wb = DbHelper.GetInstance().SelectOneCmdByIndex(cmdId);

            if (wb == null)
            {
                return null;
            }
            int pos = SystemConfig.FunctionCodeStartPos + SystemConfig.FunctionCodeLength;

            //前面的
            string resp = receiveCmd.Substring(0, pos);
            //消息长度
            string msgLen = receiveCmd.Substring(pos, SystemConfig.LengthFieldLength * 2);
            pos += SystemConfig.LengthFieldLength * 2;
            //测量点&消息流水

            int MeasureFlow = (SystemConfig.MeasurePointLen + SystemConfig.MessageFlowLen);
            string msgFlow =
                receiveCmd.Substring(pos, MeasureFlow * 2);

            pos += MeasureFlow * 2;

            Console.WriteLine(resp);
            Console.WriteLine("长度:" + msgLen);
            Console.WriteLine("消息流水:" + msgFlow);
            string bodyFrame = "";

            if (!wb.remark.Trim().Equals(""))
            {
                //写
                try
                {
                    int updateId = int.Parse(wb.remark.Trim());
                    int msgLenTen = Utils.hexToTen(msgLen) - MeasureFlow;

                    string content = receiveCmd.Substring(pos, msgLenTen * 2);


                    Console.WriteLine("updateId:" + updateId + ";;" + msgLenTen);
                    Console.WriteLine("Conte=" + content);
                    WvBean updateBean = DbHelper.GetInstance().SelectOneCmdByIndex(updateId);
                    if (updateBean != null)
                    {
                        updateBean.userValue = content;
                        int result = DbHelper.GetInstance().UpdateCmd(updateBean);
                        if (result > 0)
                        {
                            bodyFrame = "03" + msgFlow + "00";
                        }
                        else
                        {
                            bodyFrame = "03" + msgFlow + "01";
                        }
                    }
                    
                }
                catch (Exception exception)
                {
                    bodyFrame = "03" + msgFlow + "01";
                    Console.WriteLine(exception.Message);
                    Console.WriteLine(exception);
                }
            }
            else
            {
                //读
                Console.WriteLine(wb.userValue);
            }


            return null;
        }

        private string GetFrontFrame(string cmd)
        {
            return cmd.Substring(0, SystemConfig.FunctionCodeLength + SystemConfig.FunctionCodeStartPos);
        }
    }
}